from Interface import Base

class CopyZClassProduct (Base):
			"""
			Generate copy of a ZClass.
			"""
			
			def __init__(self):
					""" __init__ method """
			
			def showWelcome(self):
					"""
					Print Welcome Screen
					"""
					
			def editSetup(self):
					"""
					Print Setup Screen
					"""
			
			def editSetup_Product(self):
					"""
					Print Setup Screen to choose product
					"""
			
			def editSetup_ZClass(self,par_saved):
					"""
					Print Setup Screen to choose ZClass
					par_saved decides whether a message about a successful previous "save"-action should appear. 
					  0 : no
						1 : yes
					"""
			
			def saveSetup(self):
					"""
					Save Setup
					"""
			
			def SetupBases(self):
					"""
					Provide _SetupBases with information about the base classes of the ZClass 
					that is to be copied and all available base classes.
					_SetupBases called to display the setup screen to choose additional base classes
					"""
			
			def saveSetupBases(self):
					"""
					Save setup of base classes
					"""
			
			def editSetupDestination(self,par_saved=0):
					"""
					Setup of destination
					"""
			
			def saveSetupDestination(self):
					"""
					Save path of destination ZClass
					"""
			
			def create_ZClass(self):
					"""
					Show view to go on after new ZClass is created
					"""
						
			def transferData(self):
					"""
					Generate and fill a new ZClass with data of the old class
					"""
			
			def switch_ZClass(self):
					"""
					Show view to replace the old ZClass with the new one
					"""
			
			def do_switch_ZClass(self):
					"""
					Replace the old ZClass with the new one
					!!! Important: change of the classid necessary.                                   !!!
					!!! Reason: the instances of a ZClass point to their ZClass by using the classid, !!!
					!!!         they don't use the objectid normally used by the public view.         !!!
					!!! Descr.: classid is unique in the ZODB and is based on a MD5 Hash Value.       !!!
					!!!         objectid is human readable and has to be unique only in its folder.   !!!
					!!! Note:   ZClasses can contain other ZClasses. adjust classid recursively       !!!
					"""
			
			def showOldZClassSummary(self):
					"""
					Call showZClassSummary to show ZClass that is to be copied
					"""
			
			def showNewZClassSummary(self):
					"""
					Call showZClassSummary to show new ZClass
					"""
			
			def showZClassSummary(self,par_path):
					"""
					Show information about a ZClass specified by par_path
					"""
			
			def getInternalDebugInfo(self):
					"""
					Set the specific debug information 
					shown by showInternalDebugInfo (temp. product view)
					"""
			
			def showInternalDebugInfo(self):
					"""
					Show Internal Debug Information
					View should be disabled in final release
					"""
			
			def get_oldZClassPath(self):
					"""
					Return __oldZClassPath
					"""
			
			def get_newZClassPath(self):
					"""
					Return path of the new ZClass
					"""
			
			def get_ProductPath(self):
					"""
					Generate path to product of specified class
					**IMPORTANT** At the moment it's expected that the ZClass is right in the product folder
					"""
			
			def get_ProductName(self):
					"""
					Get name of selected Product
					"""
			
			def get_ZClassName(self):
					"""
					Get name of selected ZClass
					"""
			
			def get_newProductName(self):
					"""
					Get name of the destination Product
					"""
			
			def get_newProductPath(self):
					"""
					Return path to product of destination ZClass
					"""
			
			def get_newZClassName(self):
					"""
					Get name of the destination ZClass
					"""
			
			def get_subclassableClasses(self):
					"""
					Get a list of all subclassable class names
					"""
			
			def get_internalProducts(self):
					"""
					Get a list of all internal products (exclusion of all external installed products).
					Only internal products can contain ZClasses.
					Used by: Setup view to select desired product
					Note: installed product recognized by the iconname at the moment. Therefore this
					solution has to be handled with caution. Any more secure solution appreciated.
					!! Compatibility: Zope 2.4.3 !!
					!! Zope Version 2.5.x and higher not checked yet !! 
					"""
			
			def get_ZClassesOfProduct(self,par_prod):
					"""
					Get a list of all ZClasses in the specified product "par_prod"
					Used by: Setup view to select desired ZClass
					"""
			
			def init_basematrix(self):
					"""
					Generate and initialize a matrix (list with dictionaries) that contains
					information about the subclassable base classes and set the status
					whether a base clase has already been chosen by the ZClass that is to be copied
					"""
			
			def moveitem_basematrix(self,par_matrix,par_item,par_direction):
					"""
					Switch the postition of an item in the basematrix. 
					par_direction: move the item up or down?
					"""
			
			def _create_ZClass(self):
					"""
					Create a new empty ZClass using the base classes specified by the "Setup"-view
					New ID was specified in the Setup:Destination View
					"""
			
			def _create_containedZClass(self,par_path,par_container):
					"""
					Create new empty sub-ZClass(es). Necessary because the methods-view can contain a ZClass itself. 
					A recursive creation of the sub-ZClass(es) is mandatory.
					"""
			
			def get_selectedBasesList(self):
					"""
					Get selected bases of the basematrix
					"""
			